diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.42/examples/wireless/wifi-ofdm-vht-validation.cc ns-3.43/examples/wireless/wifi-ofdm-vht-validation.cc
--- ns-3.42/examples/wireless/wifi-ofdm-vht-validation.cc	2024-05-29 15:29:46.912073100 -0700
+++ ns-3.43/examples/wireless/wifi-ofdm-vht-validation.cc	2024-10-09 16:41:09.840655800 -0700
@@ -1,16 +1,5 @@
 /*
- * This program is free software; you can redistribute it and/or modify
- * it under the terms of the GNU General Public License version 2 as
- * published by the Free Software Foundation;
- *
- * This program is distributed in the hope that it will be useful,
- * but WITHOUT ANY WARRANTY; without even the implied warranty of
- * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- * GNU General Public License for more details.
- *
- * You should have received a copy of the GNU General Public License
- * along with this program; if not, write to the Free Software
- * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ * SPDX-License-Identifier: GPL-2.0-only
  *
  * Author: Sébastien Deronne <sebastien.deronne@gmail.com>
  */
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.42/examples/wireless/wifi-power-adaptation-distance.cc ns-3.43/examples/wireless/wifi-power-adaptation-distance.cc
--- ns-3.42/examples/wireless/wifi-power-adaptation-distance.cc	2024-05-29 15:29:46.912073100 -0700
+++ ns-3.43/examples/wireless/wifi-power-adaptation-distance.cc	2024-10-09 16:41:09.840655800 -0700
@@ -1,18 +1,7 @@
 /*
  * Copyright (c) 2014 Universidad de la República - Uruguay
  *
- * This program is free software; you can redistribute it and/or modify
- * it under the terms of the GNU General Public License version 2 as
- * published by the Free Software Foundation;
- *
- * This program is distributed in the hope that it will be useful,
- * but WITHOUT ANY WARRANTY; without even the implied warranty of
- * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- * GNU General Public License for more details.
- *
- * You should have received a copy of the GNU General Public License
- * along with this program; if not, write to the Free Software
- * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ * SPDX-License-Identifier: GPL-2.0-only
  *
  * Author: Matias Richart <mrichart@fing.edu.uy>
  */
@@ -210,7 +199,7 @@
      */
     Time GetCalcTxTime(DataRate rate);
 
-    std::map<Mac48Address, double> m_currentPower;  //!< Current Tx power for each sender.
+    std::map<Mac48Address, dBm_u> m_currentPower;   //!< Current Tx power for each sender.
     std::map<Mac48Address, DataRate> m_currentRate; //!< Current Tx rate for each sender.
     uint32_t m_bytesTotal;                          //!< Number of received bytes on a given state.
     double m_totalEnergy;                           //!< Energy used on a given state.
@@ -227,7 +216,7 @@
     Ptr<WifiPhy> phy = wifiDevice->GetPhy();
     SetupPhy(phy);
     DataRate dataRate = DataRate(phy->GetDefaultMode().GetDataRate(phy->GetChannelWidth()));
-    double power = phy->GetTxPowerEnd();
+    const auto power = phy->GetTxPowerEnd();
     for (uint32_t j = 0; j < stas.GetN(); j++)
     {
         Ptr<NetDevice> staDevice = stas.Get(j);
@@ -392,8 +381,8 @@
 int
 main(int argc, char* argv[])
 {
-    double maxPower{17};
-    double minPower{0};
+    dBm_u maxPower{17};
+    dBm_u minPower{0};
     uint32_t powerLevels{18};
 
     uint32_t rtsThreshold{2346};
@@ -404,7 +393,7 @@
     int sta1_x{5};
     int sta1_y{0};
     uint32_t steps{200};
-    uint32_t stepsSize{1};
+    meter_u stepsSize{1};
     Time stepsTime{"1s"};
 
     CommandLine cmd(__FILE__);
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.42/examples/wireless/wifi-power-adaptation-interference.cc ns-3.43/examples/wireless/wifi-power-adaptation-interference.cc
--- ns-3.42/examples/wireless/wifi-power-adaptation-interference.cc	2024-05-29 15:29:46.912073100 -0700
+++ ns-3.43/examples/wireless/wifi-power-adaptation-interference.cc	2024-10-09 16:41:09.840655800 -0700
@@ -1,18 +1,7 @@
 /*
  * Copyright (c) 2014 Universidad de la República - Uruguay
  *
- * This program is free software; you can redistribute it and/or modify
- * it under the terms of the GNU General Public License version 2 as
- * published by the Free Software Foundation;
- *
- * This program is distributed in the hope that it will be useful,
- * but WITHOUT ANY WARRANTY; without even the implied warranty of
- * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- * GNU General Public License for more details.
- *
- * You should have received a copy of the GNU General Public License
- * along with this program; if not, write to the Free Software
- * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ * SPDX-License-Identifier: GPL-2.0-only
  *
  * Author: Matias Richart <mrichart@fing.edu.uy>
  */
@@ -208,7 +197,7 @@
      */
     Time GetCalcTxTime(DataRate rate);
 
-    std::map<Mac48Address, double> m_currentPower;  //!< Current Tx power for each sender.
+    std::map<Mac48Address, dBm_u> m_currentPower;   //!< Current Tx power for each sender.
     std::map<Mac48Address, DataRate> m_currentRate; //!< Current Tx rate for each sender.
     uint32_t m_bytesTotal;                          //!< Number of received bytes.
     double m_totalEnergy;                           //!< Energy used.
@@ -237,7 +226,7 @@
     Ptr<WifiPhy> phy = wifiDevice->GetPhy();
     SetupPhy(phy);
     DataRate dataRate = DataRate(phy->GetDefaultMode().GetDataRate(phy->GetChannelWidth()));
-    double power = phy->GetTxPowerEnd();
+    const auto power = phy->GetTxPowerEnd();
     for (uint32_t j = 0; j < stas.GetN(); j++)
     {
         Ptr<NetDevice> staDevice = stas.Get(j);
@@ -456,8 +445,8 @@
 {
     // LogComponentEnable("ConstantRateWifiManager", LOG_LEVEL_FUNCTION);
 
-    double maxPower{17};
-    double minPower{0};
+    dBm_u maxPower{17};
+    dBm_u minPower{0};
     uint32_t powerLevels{18};
 
     uint32_t rtsThreshold{2346};
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.42/examples/wireless/wifi-rate-adaptation-distance.cc ns-3.43/examples/wireless/wifi-rate-adaptation-distance.cc
--- ns-3.42/examples/wireless/wifi-rate-adaptation-distance.cc	2024-05-29 15:29:46.912073100 -0700
+++ ns-3.43/examples/wireless/wifi-rate-adaptation-distance.cc	2024-10-09 16:41:09.840655800 -0700
@@ -1,18 +1,7 @@
 /*
  * Copyright (c) 2014 Universidad de la República - Uruguay
  *
- * This program is free software; you can redistribute it and/or modify
- * it under the terms of the GNU General Public License version 2 as
- * published by the Free Software Foundation;
- *
- * This program is distributed in the hope that it will be useful,
- * but WITHOUT ANY WARRANTY; without even the implied warranty of
- * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- * GNU General Public License for more details.
- *
- * You should have received a copy of the GNU General Public License
- * along with this program; if not, write to the Free Software
- * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ * SPDX-License-Identifier: GPL-2.0-only
  *
  * Author: Matías Richart <mrichart@fing.edu.uy>
  */
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.42/examples/wireless/wifi-simple-adhoc.cc ns-3.43/examples/wireless/wifi-simple-adhoc.cc
--- ns-3.42/examples/wireless/wifi-simple-adhoc.cc	2024-05-29 15:29:46.912073100 -0700
+++ ns-3.43/examples/wireless/wifi-simple-adhoc.cc	2024-10-09 16:41:09.840655800 -0700
@@ -1,18 +1,7 @@
 /*
  * Copyright (c) 2009 The Boeing Company
  *
- * This program is free software; you can redistribute it and/or modify
- * it under the terms of the GNU General Public License version 2 as
- * published by the Free Software Foundation;
- *
- * This program is distributed in the hope that it will be useful,
- * but WITHOUT ANY WARRANTY; without even the implied warranty of
- * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- * GNU General Public License for more details.
- *
- * You should have received a copy of the GNU General Public License
- * along with this program; if not, write to the Free Software
- * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ * SPDX-License-Identifier: GPL-2.0-only
  *
  */
 
@@ -110,7 +99,7 @@
 main(int argc, char* argv[])
 {
     std::string phyMode("DsssRate1Mbps");
-    double rss{-80};           // -dBm
+    dBm_u rss{-80};
     uint32_t packetSize{1000}; // bytes
     uint32_t numPackets{1};
     Time interPacketInterval{"1s"};
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.42/examples/wireless/wifi-simple-adhoc-grid.cc ns-3.43/examples/wireless/wifi-simple-adhoc-grid.cc
--- ns-3.42/examples/wireless/wifi-simple-adhoc-grid.cc	2024-05-29 15:29:46.912073100 -0700
+++ ns-3.43/examples/wireless/wifi-simple-adhoc-grid.cc	2024-10-09 16:41:09.840655800 -0700
@@ -1,18 +1,7 @@
 /*
  * Copyright (c) 2009 University of Washington
  *
- * This program is free software; you can redistribute it and/or modify
- * it under the terms of the GNU General Public License version 2 as
- * published by the Free Software Foundation;
- *
- * This program is distributed in the hope that it will be useful,
- * but WITHOUT ANY WARRANTY; without even the implied warranty of
- * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- * GNU General Public License for more details.
- *
- * You should have received a copy of the GNU General Public License
- * along with this program; if not, write to the Free Software
- * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ * SPDX-License-Identifier: GPL-2.0-only
  *
  */
 
@@ -150,7 +139,7 @@
 main(int argc, char* argv[])
 {
     std::string phyMode{"DsssRate1Mbps"};
-    double distance{100};      // m
+    meter_u distance{100};
     uint32_t packetSize{1000}; // bytes
     uint32_t numPackets{1};
     uint32_t numNodes{25}; // by default, 5x5
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.42/examples/wireless/wifi-simple-ht-hidden-stations.cc ns-3.43/examples/wireless/wifi-simple-ht-hidden-stations.cc
--- ns-3.42/examples/wireless/wifi-simple-ht-hidden-stations.cc	2024-05-29 15:29:46.912073100 -0700
+++ ns-3.43/examples/wireless/wifi-simple-ht-hidden-stations.cc	2024-10-09 16:41:09.840655800 -0700
@@ -1,18 +1,7 @@
 /*
  * Copyright (c) 2015 Sébastien Deronne
  *
- * This program is free software; you can redistribute it and/or modify
- * it under the terms of the GNU General Public License version 2 as
- * published by the Free Software Foundation;
- *
- * This program is distributed in the hope that it will be useful,
- * but WITHOUT ANY WARRANTY; without even the implied warranty of
- * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- * GNU General Public License for more details.
- *
- * You should have received a copy of the GNU General Public License
- * along with this program; if not, write to the Free Software
- * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ * SPDX-License-Identifier: GPL-2.0-only
  *
  * Author: Sébastien Deronne <sebastien.deronne@gmail.com>
  */
@@ -139,8 +128,8 @@
                 UintegerValue(maxAmpduSize));
 
     int64_t streamNumber = 20;
-    streamNumber += wifi.AssignStreams(apDevice, streamNumber);
-    streamNumber += wifi.AssignStreams(staDevices, streamNumber);
+    streamNumber += WifiHelper::AssignStreams(apDevice, streamNumber);
+    streamNumber += WifiHelper::AssignStreams(staDevices, streamNumber);
 
     // Setting mobility model
     MobilityHelper mobility;
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.42/examples/wireless/wifi-simple-infra.cc ns-3.43/examples/wireless/wifi-simple-infra.cc
--- ns-3.42/examples/wireless/wifi-simple-infra.cc	2024-05-29 15:29:46.912073100 -0700
+++ ns-3.43/examples/wireless/wifi-simple-infra.cc	2024-10-09 16:41:09.840655800 -0700
@@ -1,18 +1,7 @@
 /*
  * Copyright (c) 2009 The Boeing Company
  *
- * This program is free software; you can redistribute it and/or modify
- * it under the terms of the GNU General Public License version 2 as
- * published by the Free Software Foundation;
- *
- * This program is distributed in the hope that it will be useful,
- * but WITHOUT ANY WARRANTY; without even the implied warranty of
- * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- * GNU General Public License for more details.
- *
- * You should have received a copy of the GNU General Public License
- * along with this program; if not, write to the Free Software
- * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ * SPDX-License-Identifier: GPL-2.0-only
  *
  */
 
@@ -143,7 +132,7 @@
 main(int argc, char* argv[])
 {
     std::string phyMode{"DsssRate1Mbps"};
-    double rss{-80};           // -dBm
+    dBm_u rss{-80};
     uint32_t packetSize{1000}; // bytes
     uint32_t numPackets{1};
     Time interval{"1s"};
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.42/examples/wireless/wifi-simple-interference.cc ns-3.43/examples/wireless/wifi-simple-interference.cc
--- ns-3.42/examples/wireless/wifi-simple-interference.cc	2024-05-29 15:29:46.916073000 -0700
+++ ns-3.43/examples/wireless/wifi-simple-interference.cc	2024-10-09 16:41:09.840655800 -0700
@@ -1,18 +1,7 @@
 /*
  * Copyright (c) 2009 The Boeing Company
  *
- * This program is free software; you can redistribute it and/or modify
- * it under the terms of the GNU General Public License version 2 as
- * published by the Free Software Foundation;
- *
- * This program is distributed in the hope that it will be useful,
- * but WITHOUT ANY WARRANTY; without even the implied warranty of
- * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- * GNU General Public License for more details.
- *
- * You should have received a copy of the GNU General Public License
- * along with this program; if not, write to the Free Software
- * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ * SPDX-License-Identifier: GPL-2.0-only
  *
  */
 
@@ -50,14 +39,14 @@
 // The configurable parameters are:
 //   - Prss (primary rss) (-80 dBm default)
 //   - Irss (interfering rss) (-95 dBm default)
-//   - delta (microseconds, (t1-t0), may be negative, default 0)
+//   - delta (t1-t0, may be negative, default 0ns)
 //   - PpacketSize (primary packet size) (bytes, default 1000)
 //   - IpacketSize (interferer packet size) (bytes, default 1000)
 //
 // For instance, for this configuration, the interfering frame arrives
 // at -90 dBm with a time offset of 3.2 microseconds:
 //
-// ./ns3 run "wifi-simple-interference --Irss=-90 --delta=3.2"
+// ./ns3 run "wifi-simple-interference --Irss=-90 --delta=3.2ns"
 //
 // Note that all ns-3 attributes (not just the ones exposed in the below
 // script) can be changed at command line; see the documentation.
@@ -77,7 +66,7 @@
 //
 // Next, try this command and look at the tcpdump-- you should see two packets
 // that are no longer interfering:
-// ./ns3 run "wifi-simple-interference --delta=30000"
+// ./ns3 run "wifi-simple-interference --delta=30000ns"
 
 #include "ns3/command-line.h"
 #include "ns3/config.h"
@@ -161,9 +150,9 @@
 main(int argc, char* argv[])
 {
     std::string phyMode{"DsssRate1Mbps"};
-    double Prss{-80};           // -dBm
-    double Irss{-95};           // -dBm
-    double delta{0};            // microseconds
+    dBm_u Prss{-80};
+    dBm_u Irss{-95};
+    Time delta{"0ns"};
     uint32_t PpacketSize{1000}; // bytes
     uint32_t IpacketSize{1000}; // bytes
     bool verbose{false};
@@ -172,7 +161,7 @@
     uint32_t numPackets{1};
     Time interPacketInterval{"1s"};
     Time startTime{"10s"};
-    double distanceToRx{100.0}; // meters
+    meter_u distanceToRx{100.0};
 
     double offset{91}; // This is a magic number used to set the
                        // transmit power, based on other configuration
@@ -180,7 +169,7 @@
     cmd.AddValue("phyMode", "Wifi Phy mode", phyMode);
     cmd.AddValue("Prss", "Intended primary received signal strength (dBm)", Prss);
     cmd.AddValue("Irss", "Intended interfering received signal strength (dBm)", Irss);
-    cmd.AddValue("delta", "time offset (microseconds) for interfering signal", delta);
+    cmd.AddValue("delta", "time offset for interfering signal", delta);
     cmd.AddValue("PpacketSize", "size of application packet sent", PpacketSize);
     cmd.AddValue("IpacketSize", "size of interfering packet sent", IpacketSize);
     cmd.AddValue("verbose", "turn on all WifiNetDevice log components", verbose);
@@ -264,7 +253,7 @@
 
     // Output what we are doing
     NS_LOG_UNCOND("Primary packet RSS=" << Prss << " dBm and interferer RSS=" << Irss
-                                        << " dBm at time offset=" << delta << " ms");
+                                        << " dBm at time offset=" << delta.As(Time::US));
 
     Simulator::ScheduleWithContext(source->GetNode()->GetId(),
                                    startTime,
@@ -275,7 +264,7 @@
                                    interPacketInterval);
 
     Simulator::ScheduleWithContext(interferer->GetNode()->GetId(),
-                                   startTime + Seconds(delta / 1000000.0),
+                                   startTime + delta,
                                    &GenerateTraffic,
                                    interferer,
                                    IpacketSize,
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.42/examples/wireless/wifi-sleep.cc ns-3.43/examples/wireless/wifi-sleep.cc
--- ns-3.42/examples/wireless/wifi-sleep.cc	2024-05-29 15:29:46.916073000 -0700
+++ ns-3.43/examples/wireless/wifi-sleep.cc	2024-10-09 16:41:09.840655800 -0700
@@ -2,18 +2,7 @@
  * Copyright (c) 2009 The Boeing Company
  *               2014 Universita' degli Studi di Napoli "Federico II"
  *
- * This program is free software; you can redistribute it and/or modify
- * it under the terms of the GNU General Public License version 2 as
- * published by the Free Software Foundation;
- *
- * This program is distributed in the hope that it will be useful,
- * but WITHOUT ANY WARRANTY; without even the implied warranty of
- * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- * GNU General Public License for more details.
- *
- * You should have received a copy of the GNU General Public License
- * along with this program; if not, write to the Free Software
- * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ * SPDX-License-Identifier: GPL-2.0-only
  *
  */
 
@@ -113,14 +102,14 @@
     DataRate dataRate{"1Mb/s"};
     uint32_t packetSize{1000}; // bytes
     Time duration{"10s"};
-    double initialEnergy{7.5}; // joule
-    double voltage{3.0};       // volts
-    double txPowerStart{0.0};  // dbm
-    double txPowerEnd{15.0};   // dbm
+    joule_u initialEnergy{7.5};
+    volt_u voltage{3.0};
+    dBm_u txPowerStart{0.0};
+    dBm_u txPowerEnd{15.0};
     uint32_t nTxPowerLevels{16};
     uint32_t txPowerLevel{0};
-    double idleCurrent{0.273}; // Ampere
-    double txCurrent{0.380};   // Ampere
+    ampere_u idleCurrent{0.273};
+    ampere_u txCurrent{0.380};
     bool verbose{false};
 
     CommandLine cmd(__FILE__);
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.42/examples/wireless/wifi-spatial-reuse.cc ns-3.43/examples/wireless/wifi-spatial-reuse.cc
--- ns-3.42/examples/wireless/wifi-spatial-reuse.cc	2024-05-29 15:29:46.916073000 -0700
+++ ns-3.43/examples/wireless/wifi-spatial-reuse.cc	2024-10-09 16:41:09.840655800 -0700
@@ -1,18 +1,7 @@
 /*
  * Copyright (c) 2019 University of Washington
  *
- * This program is free software; you can redistribute it and/or modify
- * it under the terms of the GNU General Public License version 2 as
- * published by the Free Software Foundation;
- *
- * This program is distributed in the hope that it will be useful,
- * but WITHOUT ANY WARRANTY; without even the implied warranty of
- * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- * GNU General Public License for more details.
- *
- * You should have received a copy of the GNU General Public License
- * along with this program; if not, write to the Free Software
- * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ * SPDX-License-Identifier: GPL-2.0-only
  *
  * Author: Sébastien Deronne <sebastien.deronne@gmail.com>
  */
@@ -157,24 +146,24 @@
 main(int argc, char* argv[])
 {
     Time duration{"10s"};
-    double d1{30.0};            // meters
-    double d2{30.0};            // meters
-    double d3{150.0};           // meters
-    double powSta1{10.0};       // dBm
-    double powSta2{10.0};       // dBm
-    double powAp1{21.0};        // dBm
-    double powAp2{21.0};        // dBm
-    double ccaEdTrSta1{-62};    // dBm
-    double ccaEdTrSta2{-62};    // dBm
-    double ccaEdTrAp1{-62};     // dBm
-    double ccaEdTrAp2{-62};     // dBm
-    double minimumRssi{-82};    // dBm
+    meter_u d1{30.0};
+    meter_u d2{30.0};
+    meter_u d3{150.0};
+    dBm_u powSta1{10.0};
+    dBm_u powSta2{10.0};
+    dBm_u powAp1{21.0};
+    dBm_u powAp2{21.0};
+    dBm_u ccaEdTrSta1{-62};
+    dBm_u ccaEdTrSta2{-62};
+    dBm_u ccaEdTrAp1{-62};
+    dBm_u ccaEdTrAp2{-62};
+    dBm_u minimumRssi{-82};
     int channelWidth{20};       // MHz
     uint32_t payloadSize{1500}; // bytes
     uint32_t mcs{0};            // MCS value
     Time interval{"1ms"};
     bool enableObssPd{true};
-    double obssPdThreshold{-72.0}; // dBm
+    dBm_u obssPdThreshold{-72.0};
 
     CommandLine cmd(__FILE__);
     cmd.AddValue("duration", "Duration of simulation", duration);
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.42/examples/wireless/wifi-spectrum-per-example.cc ns-3.43/examples/wireless/wifi-spectrum-per-example.cc
--- ns-3.42/examples/wireless/wifi-spectrum-per-example.cc	2024-05-29 15:29:46.916073000 -0700
+++ ns-3.43/examples/wireless/wifi-spectrum-per-example.cc	2024-10-09 16:41:09.844655800 -0700
@@ -2,18 +2,7 @@
  * Copyright (c) 2009 MIRKO BANCHI
  * Copyright (c) 2015 University of Washington
  *
- * This program is free software; you can redistribute it and/or modify
- * it under the terms of the GNU General Public License version 2 as
- * published by the Free Software Foundation;
- *
- * This program is distributed in the hope that it will be useful,
- * but WITHOUT ANY WARRANTY; without even the implied warranty of
- * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- * GNU General Public License for more details.
- *
- * You should have received a copy of the GNU General Public License
- * along with this program; if not, write to the Free Software
- * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ * SPDX-License-Identifier: GPL-2.0-only
  *
  * Authors: Mirko Banchi <mk.banchi@gmail.com>
  *          Sebastien Deronne <sebastien.deronne@gmail.com>
@@ -129,7 +118,7 @@
 main(int argc, char* argv[])
 {
     bool udp{true};
-    double distance{50};
+    meter_u distance{50};
     Time simulationTime{"10s"};
     uint16_t index{256};
     std::string wifiType{"ns3::SpectrumWifiPhy"};
@@ -181,7 +170,7 @@
         NodeContainer wifiApNode;
         wifiApNode.Create(1);
 
-        YansWifiPhyHelper phy;
+        YansWifiPhyHelper yansPhy;
         SpectrumWifiPhyHelper spectrumPhy;
         if (wifiType == "ns3::YansWifiPhy")
         {
@@ -190,9 +179,9 @@
                                        "Frequency",
                                        DoubleValue(5.180e9));
             channel.SetPropagationDelay("ns3::ConstantSpeedPropagationDelayModel");
-            phy.SetChannel(channel.Create());
-            phy.Set("TxPowerStart", DoubleValue(1)); // dBm (1.26 mW)
-            phy.Set("TxPowerEnd", DoubleValue(1));
+            yansPhy.SetChannel(channel.Create());
+            yansPhy.Set("TxPowerStart", DoubleValue(1)); // dBm (1.26 mW)
+            yansPhy.Set("TxPowerEnd", DoubleValue(1));
         }
         else if (wifiType == "ns3::SpectrumWifiPhy")
         {
@@ -397,17 +386,19 @@
         if (wifiType == "ns3::YansWifiPhy")
         {
             mac.SetType("ns3::StaWifiMac", "Ssid", SsidValue(ssid));
-            phy.Set("ChannelSettings",
-                    StringValue(std::string("{0, ") + (i <= 15 ? "20" : "40") + ", BAND_5GHZ, 0}"));
-            staDevice = wifi.Install(phy, mac, wifiStaNode);
+            yansPhy.Set(
+                "ChannelSettings",
+                StringValue(std::string("{0, ") + (i <= 15 ? "20" : "40") + ", BAND_5GHZ, 0}"));
+            staDevice = wifi.Install(yansPhy, mac, wifiStaNode);
             mac.SetType("ns3::ApWifiMac", "Ssid", SsidValue(ssid));
-            apDevice = wifi.Install(phy, mac, wifiApNode);
+            apDevice = wifi.Install(yansPhy, mac, wifiApNode);
         }
         else if (wifiType == "ns3::SpectrumWifiPhy")
         {
             mac.SetType("ns3::StaWifiMac", "Ssid", SsidValue(ssid));
-            phy.Set("ChannelSettings",
-                    StringValue(std::string("{0, ") + (i <= 15 ? "20" : "40") + ", BAND_5GHZ, 0}"));
+            spectrumPhy.Set(
+                "ChannelSettings",
+                StringValue(std::string("{0, ") + (i <= 15 ? "20" : "40") + ", BAND_5GHZ, 0}"));
             staDevice = wifi.Install(spectrumPhy, mac, wifiStaNode);
             mac.SetType("ns3::ApWifiMac", "Ssid", SsidValue(ssid));
             apDevice = wifi.Install(spectrumPhy, mac, wifiApNode);
@@ -491,11 +482,15 @@
 
         if (enablePcap)
         {
+            auto& phy = wifiType == "ns3::YansWifiPhy" ? dynamic_cast<WifiPhyHelper&>(yansPhy)
+                                                       : dynamic_cast<WifiPhyHelper&>(spectrumPhy);
+
             phy.SetPcapDataLinkType(WifiPhyHelper::DLT_IEEE802_11_RADIO);
             std::stringstream ss;
             ss << "wifi-spectrum-per-example-" << i;
             phy.EnablePcap(ss.str(), apDevice);
         }
+
         g_signalDbmAvg = 0;
         g_noiseDbmAvg = 0;
         g_samples = 0;
@@ -504,7 +499,7 @@
         Simulator::Run();
 
         auto throughput = 0.0;
-        auto totalPacketsThrough = 0.0;
+        uint64_t totalPacketsThrough = 0;
         if (udp)
         {
             // UDP
@@ -516,7 +511,7 @@
         {
             // TCP
             auto totalBytesRx = DynamicCast<PacketSink>(serverApp.Get(0))->GetTotalRx();
-            totalPacketsThrough = totalBytesRx / tcpPacketSize;
+            totalPacketsThrough = static_cast<uint64_t>(totalBytesRx / tcpPacketSize);
             throughput = totalBytesRx * 8 / simulationTime.GetMicroSeconds(); // Mbit/s
         }
         std::cout << std::setw(5) << i << std::setw(6) << (i % 8) << std::setprecision(2)
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.42/examples/wireless/wifi-spectrum-per-interference.cc ns-3.43/examples/wireless/wifi-spectrum-per-interference.cc
--- ns-3.42/examples/wireless/wifi-spectrum-per-interference.cc	2024-05-29 15:29:46.916073000 -0700
+++ ns-3.43/examples/wireless/wifi-spectrum-per-interference.cc	2024-10-09 16:41:09.844655800 -0700
@@ -2,18 +2,7 @@
  * Copyright (c) 2009 MIRKO BANCHI
  * Copyright (c) 2015 University of Washington
  *
- * This program is free software; you can redistribute it and/or modify
- * it under the terms of the GNU General Public License version 2 as
- * published by the Free Software Foundation;
- *
- * This program is distributed in the hope that it will be useful,
- * but WITHOUT ANY WARRANTY; without even the implied warranty of
- * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- * GNU General Public License for more details.
- *
- * You should have received a copy of the GNU General Public License
- * along with this program; if not, write to the Free Software
- * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ * SPDX-License-Identifier: GPL-2.0-only
  *
  * Authors: Mirko Banchi <mk.banchi@gmail.com>
  *          Sebastien Deronne <sebastien.deronne@gmail.com>
@@ -180,14 +169,14 @@
 main(int argc, char* argv[])
 {
     bool udp{true};
-    double distance{50};
+    meter_u distance{50};
     Time simulationTime{"10s"};
     uint16_t index{256};
     std::string wifiType{"ns3::SpectrumWifiPhy"};
     std::string errorModelType{"ns3::NistErrorRateModel"};
     bool enablePcap{false};
     const uint32_t tcpPacketSize{1448};
-    double waveformPower{0};
+    Watt_u waveformPower{0};
 
     CommandLine cmd(__FILE__);
     cmd.AddValue("simulationTime", "Simulation time", simulationTime);
